/*
 This project is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Deviation is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Deviation.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "common.h"
#include "pages.h"
#include "gui/gui.h"

#include "../common/_usb_page.c"
static u8 _action_cb(u32 button, u8 flags, void *data);

static void _draw_page(u8 enable)
{
    PAGE_RemoveAllObjects();
    PAGE_ShowHeader(_tr("USB"));
    PAGE_SetActionCB(_action_cb);

    sprintf(up->tmpstr, "%s %s",
            _tr("Press ENT to turn \nUSB drive:"),
            enable == 0 ? _tr("On") : _tr("Off"));
    GUI_CreateLabelBox(0, 15, LCD_WIDTH, 40, &DEFAULT_FONT, NULL, NULL, up->tmpstr);
}

static u8 _action_cb(u32 button, u8 flags, void *data)
{
    (void)data;
    if ((flags & BUTTON_PRESS) || (flags & BUTTON_LONGPRESS)) {
	
        if (CHAN_ButtonIsPressed(button, BUT_EXIT)) {
            PAGE_ChangeByID(PAGEID_MENU, 0);
        }
        else {
			#ifndef EMULATOR
			if (CHAN_ButtonIsPressed(button, BUT_ENTER)) {
				// USB_Enable(1);
			}
			
			// USB_Joystick_Send();
			
			if (CHAN_ButtonIsPressed(button, BUT_UP)) {
				PrevXferComplete = 1;
				USB_Joystick_Send();
					// sprintf(up->tmpstr, "Btable: %ld %ld", PMaddrV[0], PMaddrV[10]),
					// GUI_CreateLabelBox(0, 25, 128, 8,&TINY_FONT, NULL, NULL, up->tmpstr);
					sprintf(up->tmpstr, "EP013:%ld %ld %ld", PMaddrV[1],PMaddrV[3],PMaddrV[7]),
					GUI_CreateLabelBox(0, 25, 128, 8,&TINY_FONT, NULL, NULL, up->tmpstr);
            }
			if (CHAN_ButtonIsPressed(button, BUT_DOWN)) {
					USB_Enable(1);
					sprintf(up->tmpstr, "USB Enable !"),
					GUI_CreateLabelBox(0, 33, 128, 8,&TINY_FONT, NULL, NULL, up->tmpstr);
					// sprintf(up->tmpstr, "EP0:%ld %ld", PMaddrV[1], PMaddrV[2]),
					// GUI_CreateLabelBox(0, 33, 128, 8,&TINY_FONT, NULL, NULL, up->tmpstr);
            }
			if (CHAN_ButtonIsPressed(button, BUT_LEFT)) {
					// USB_Enable(1);
					// sprintf(up->tmpstr, "EP1:%ld %ld", PMaddrV[3], PMaddrV[4]),
					// GUI_CreateLabelBox(0, 41, 128, 8,&TINY_FONT, NULL, NULL, up->tmpstr);
					// sprintf(up->tmpstr, "Btable: %ld %ld", PMaddrV[0], PMaddrV[10]),
					// GUI_CreateLabelBox(0, 25, 128, 8,&TINY_FONT, NULL, NULL, up->tmpstr);
            }
			if (CHAN_ButtonIsPressed(button, BUT_RIGHT)) {
					// sprintf(up->tmpstr, "EP2:%ld %ld", PMaddrV[5], PMaddrV[6]),
					// GUI_CreateLabelBox(0, 49, 128, 8,&TINY_FONT, NULL, NULL, up->tmpstr);
					sprintf(up->tmpstr, "BT: %ld %ld %ld %ld", PMaddrV[10], PMaddrV[11], PMaddrV[12], PMaddrV[13]),
					GUI_CreateLabelBox(0, 49, 128, 8,&TINY_FONT, NULL, NULL, up->tmpstr);
            }
			
			#endif    // #ifndef EMULATOR
			// only one callback can handle a button press, so we don't handle BUT_ENTER here, let it handled by press cb
            return 0;
        }
		
    }
    return 1;
}
